"use strict";
// Copyright IBM Corp. 2019. All Rights Reserved.
// Node module: @loopback/example-context
// This file is licensed under the MIT License.
// License text available at https://opensource.org/licenses/MIT
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const context_1 = require("@loopback/context");
/**
 * A greeter service
 */
let Greeter = class Greeter {
    constructor(
    /**
     * Inject configuration for this bound instance
     */
    settings = {}) {
        this.settings = settings;
    }
    greet(name) {
        const prefix = this.settings.prefix ? `${this.settings.prefix}` : '';
        const date = this.settings.includeDate
            ? `[${new Date().toISOString()}]`
            : '';
        return `${date} ${prefix}: Hello, ${name}`;
    }
};
Greeter = __decorate([
    __param(0, context_1.config()),
    __metadata("design:paramtypes", [Object])
], Greeter);
async function main() {
    const ctx = new context_1.Context();
    // Configure `greeter` with `{prefix: '>>>', includeDate: true}`
    ctx
        .configure('greeter')
        .to({ prefix: '>>>', includeDate: true });
    ctx.bind('greeter').toClass(Greeter);
    const greeter = await ctx.get('greeter');
    console.log(greeter.greet('Ray'));
}
exports.main = main;
if (require.main === module) {
    main().catch(err => {
        console.error(err);
        process.exit(1);
    });
}
//# sourceMappingURL=configuration-injection.js.map