"use strict";
// Copyright IBM Corp. 2019. All Rights Reserved.
// Node module: @loopback/example-context
// This file is licensed under the MIT License.
// License text available at https://opensource.org/licenses/MIT
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const context_1 = require("@loopback/context");
/**
 * Custom resolver function for bindings
 * @param ctx The current context
 * @param injection Metadata about the injection
 * @param session Current resolution session
 */
const resolve = (ctx, injection, session) => {
    console.log('Context: %s Binding: %s', ctx.name, session.currentBinding.key);
    const targetName = context_1.ResolutionSession.describeInjection(injection).targetName;
    console.log('Injection: %s', targetName);
    return injection.member === 'prefix' ? new Date().toISOString() : 'John';
};
/**
 * A class with dependency injection
 */
let Greeter = class Greeter {
    constructor(name) {
        this.name = name;
        this.prefix = '';
    }
    hello() {
        return `[${this.prefix}] Hello, ${this.name}`;
    }
};
__decorate([
    context_1.inject('', {}, resolve),
    __metadata("design:type", Object)
], Greeter.prototype, "prefix", void 0);
Greeter = __decorate([
    __param(0, context_1.inject('', {}, resolve)),
    __metadata("design:paramtypes", [String])
], Greeter);
const GREETER = context_1.BindingKey.create('greeter');
async function main() {
    const ctx = new context_1.Context('invocation-context');
    ctx.bind(GREETER).toClass(Greeter);
    const greeter = await ctx.get(GREETER);
    console.log(greeter.hello());
}
exports.main = main;
if (require.main === module) {
    main().catch(err => {
        console.error(err);
        process.exit(1);
    });
}
//# sourceMappingURL=custom-inject-resolve.js.map